import java.awt.*;
import javax.swing.*;

/**
 * Dialog for the progress bar.
 */
public class ProgressFrame extends JDialog{
	JProgressBar bar;
	Progressable utils;
	
	/**
	 * Constructor:
	 * @param f Frame this dialog belongs to.
	 * @param p Object holding the progress info.
	 * @param total The total progress to set the progress bar to.
	 */
	public ProgressFrame(Frame f, Progressable p, int total){
		super(f, "Progress", true);
		
		// create the progress abr.
		getContentPane().add((bar=new JProgressBar(JProgressBar.HORIZONTAL, 0, total)));
		// create empty space around it, to make the window look nice.
		getContentPane().add(new JPanel(), BorderLayout.NORTH);
		getContentPane().add(new JPanel(), BorderLayout.SOUTH);
		getContentPane().add(new JPanel(), BorderLayout.EAST);
		getContentPane().add(new JPanel(), BorderLayout.WEST);
		setResizable(false);
		
		utils=p;
		// thread for looking at the current progress.
		Thread t=new Thread(new Runnable(){
			public void run(){
				int count;
				while((count=utils.getSetCurrentProgress(-1))!=0){
					bar.setValue(count);
					try{
						Thread.sleep(100);
					}catch(Exception e){}
				}
				dispose();
			}
		});
		t.start();
		
		pack();
		setLocation((f.getWidth()-getWidth())/2, (f.getHeight()-getHeight())/2);
		setVisible(true);
	}
}
