import java.util.*;
import java.awt.*;

/**
 * General shape class.
 */
public class Shape{
	Vector pos; // positions, XYPairs.
	Color color;
	
	/** Constructor: */
	public Shape(){
		pos=new Vector();
		color=new Color(255, 0, 0);
	}
	/** Constructor:
	 * @param xv Vector of XYPairs.
	 */
	public Shape(Vector xv){
		pos=xv;
		color=new Color(255, 0, 0);
	}
	/** Constructor:
	 * @param c Color.
	 */
	public Shape(Color c){
		pos=new Vector();
		color=c;
	}
	/** Constructor:
	 * @param xv Vector of XYPairs.
	 * @param c Color.
	 */
	public Shape(Vector xv, Color c){
		pos=xv;
		color=c;
	}
	
	/** Paints this shape.
	 * @param g Graphics object to paint on.
	 */
	public void paint(Graphics g){
		XYPair xy;
		Color c=g.getColor();
		g.setColor(color);
		
		// Go through all positions and draw them.
		for(int i=0; i<pos.size(); i++){
			xy=(XYPair)pos.elementAt(i);
			g.fillRect(xy.x, xy.y, 1, 1);
		}
		g.setColor(c);
	}
	
	/**
	 * Tests if a point is within this shape.
	 * @param x X coordinate.
	 * @param y Y coordinate.
	 * @return true if it's within the shape, false otherwise.
	 */
	public boolean hitTest(int x, int y){
		for(int i=0; i<pos.size(); i++){
			if(((XYPair)pos.get(i)).x==x && ((XYPair)pos.get(i)).y==y)
				return true;
		}
		return false;
	}
}
