import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


/**
 * Dialog for letting the user select dimensions for a new window.
 */
public class SizeInputDialog extends JDialog {
	JTextField wid, het;
	int width=0;
	int height=0;
	boolean hitOK=false;
	
	/**
	 * Constructor:
	 * @param f Frame this dialog belongs to.
	 * @param w Initial width.
	 * @param h Initial height.
	 */
	public SizeInputDialog(Frame f, int w, int h){
		super(f, "Choose image size", true);
		// create the 2 input fields for width and height.
		JPanel jp=new JPanel();
		jp.add(new JLabel("Width:"));
		jp.add((wid=new JTextField(""+w, 3)));
		
		jp.add(new JLabel("Height:"));
		jp.add((het=new JTextField(""+h, 3)));
		
		getContentPane().add(jp, BorderLayout.CENTER);
		
		// Create the 2 buttons allowing the user to confirm the input or cancel.
		jp=new JPanel();
		JButton b=new JButton("OK");
		b.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try{
					width=Integer.parseInt(wid.getText());
					height=Integer.parseInt(het.getText());
					if(width>0 && height>0){
						hitOK=true;
						dispose();
					}
				}catch(Exception ex){
				}
			}
		});
		jp.add(b);
		
		b=new JButton("Cancel");
		b.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				dispose();
			}
		});
		jp.add(b);
		getContentPane().add(jp, BorderLayout.SOUTH);
		
		setLocation(f.getWidth()/2-100, f.getHeight()/2-50);
		pack();
		
		setVisible(true);
	}
}
